## libm2k 0.9.0

=== CMakeLists.txt ===
#
# Copyright (c) 2019 Analog Devices Inc.
#
# This file is part of libm2k
# (see http://www.github.com/analogdevicesinc/libm2k).
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 2.1 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 3.1.3)

if(NOT ${CMAKE_VERSION} VERSION_LESS "3.18.0")
	# https://cmake.org/cmake/help/v3.18/policy/CMP0068.html
	cmake_policy(SET CMP0068 NEW)
endif()

set(LIBM2K_VERSION_MAJOR 0)
set(LIBM2K_VERSION_MINOR 9)
set(LIBM2K_VERSION_PATCH 0)
set(LIBM2K_VERSION "${LIBM2K_VERSION_MAJOR}.${LIBM2K_VERSION_MINOR}.${LIBM2K_VERSION_PATCH}")

project(libm2k LANGUAGES CXX VERSION ${LIBM2K_VERSION})

include(GNUInstallDirs)
include(FindGit OPTIONAL)

list(INSERT CMAKE_MODULE_PATH 0 ${CMAKE_SOURCE_DIR}/cmake/Modules)

# build a shared library by default
set(BUILD_SHARED_LIBS ON CACHE BOOL "Build shared libraries")

# setup install location for MacOS frameworks
set(OSX_INSTALL_FRAMEWORKSDIR "/Library/Frameworks" CACHE STRING "Installation directory for frameworks")

# generate docs by default
option(ENABLE_DOC "Generate documentation with Doxygen" OFF)
option(BUILD_EXAMPLES "Build the default examples" OFF)
option(ENABLE_LOG "Build with logging support" OFF)
option(ENABLE_EXCEPTIONS "Build with exception handling support" ON)
option(ENABLE_PYTHON "Build Python bindings" ON)
option(ENABLE_CSHARP "Build C# bindings" OFF)
option(ENABLE_LABVIEW "Build LabVIEW bindings" OFF)
option(ENABLE_TOOLS "Build the tools" OFF)
option(INSTALL_UDEV_RULES "Install udev rules for the M2K" ON)

if (ENABLE_DOC)
    add_subdirectory(doc)
endif()

if (ENABLE_PYTHON OR ENABLE_CSHARP)
	FIND_PACKAGE(SWIG REQUIRED)
endif()

set(CMAKE_SHARED_LIBRARY_PREFIX "")
if (WIN32)
	set(CMAKE_SHARED_MODULE_PREFIX "")
	set(CMAKE_STATIC_LIBRARY_PREFIX "")
	SET(CMAKE_IMPORT_LIBRARY_PREFIX "")
endif()

# Get the GIT hash of the latest commit
if (GIT_FOUND)
	execute_process(
		COMMAND ${GIT_EXECUTABLE} rev-parse --show-toplevel
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		OUTPUT_VARIABLE LIBM2K_GIT_REPO
		OUTPUT_STRIP_TRAILING_WHITESPACE
	)

	if (${LIBM2K_GIT_REPO} MATCHES ${CMAKE_CURRENT_SOURCE_DIR})
		execute_process(
			COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			OUTPUT_VARIABLE LIBM2K_VERSION_GIT
			OUTPUT_STRIP_TRAILING_WHITESPACE
		)
	endif()
endif()

set(LIBM2K_VERSION_FULL v${PROJECT_VERSION} - ${LIBM2K_VERSION_GIT})

if (ENABLE_LOG)
	find_package(glog)
	if (NOT TARGET glog::glog)
		find_library(GLOG_LIBRARIES NAMES glog)
		find_path(GLOG_INCLUDE_DIRS glog/logging.h)
		add_library(glog::glog SHARED IMPORTED)
		set_target_properties(glog::glog
				PROPERTIES
				INTERFACE_INCLUDE_DIRECTORIES ${GLOG_INCLUDE_DIRS}
				IMPORTED_LOCATION ${GLOG_LIBRARIES})
	endif()
	message(STATUS "Building with logging support(glog).")
endif()

#Enable or disable exception handling
if (NOT ENABLE_EXCEPTIONS)
	add_definitions(-D_EXCEPTIONS=0)
	if(NOT MSVC)
		remove_definitions("-fexceptions")
		add_definitions("-fno-exceptions")
	endif()
else()
	add_definitions(-D_EXCEPTIONS=1)
	if(NOT MSVC)
		remove_definitions("-fno-exceptions")
		add_definitions("-fexceptions")
	endif()
endif()

configure_file(${CMAKE_SOURCE_DIR}/version.hpp.cmakein ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/version.hpp @ONLY)
configure_file(${CMAKE_SOURCE_DIR}/cmake/libm2kConfig.cmake ${CMAKE_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake @ONLY)

# Set the default install path to /usr
if (NOT WIN32 AND CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
        set(CMAKE_INSTALL_PREFIX "/usr/local" CACHE PATH "default install path" FORCE)
endif()

# get rid of Visual Studio's default "Debug" and "Release" output directories
if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG   ${CMAKE_BINARY_DIR})
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_DEBUG   ${CMAKE_BINARY_DIR})
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_DEBUG   ${CMAKE_BINARY_DIR})

    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE ${CMAKE_BINARY_DIR})
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_RELEASE ${CMAKE_BINARY_DIR})
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_RELEASE ${CMAKE_BINARY_DIR})
endif()

set(INSTALL_PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig"
	CACHE PATH "Installation directory for pkgconfig (.pc) files")
mark_as_advanced(INSTALL_PKGCONFIG_DIR)

# handle RPATH issues on OS X
if(APPLE)
	set(CMAKE_MACOSX_RPATH ON)
	set(CMAKE_SKIP_BUILD_RPATH TRUE)
	set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
	set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_LIBDIR}")
	set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
	list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_LIBDIR}" isSystemDir)
	if("${isSystemDir}" STREQUAL "-1")
		set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_LIBDIR}")
	endif()
endif()

if (NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
		"Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel."
		FORCE)
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS None Debug Release RelWithDebInfo MinSizeRel)
endif()

list(FIND CMAKE_CXX_COMPILE_FEATURES cxx_constexpr OUT_CONSTEXPR)
if (NOT "${OUT_CONSTEXPR}" STREQUAL "-1")
	add_definitions(-DHAS_CONSTEXPR=1)
endif()

#Find libiio and link it to the targets generated by this project
find_library(IIO_LIBRARIES NAMES iio libiio)
find_path(IIO_INCLUDE_DIRS iio.h)

#set(CMAKE_C_FLAGS "${CMAKE_CXX_FLAGS}")
if (NOT WIN32)
	set(CMAKE_CXX_FLAGS "-Wall ${CMAKE_CXX_FLAGS}")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic -std=c++11")

#Add and build the source code subdirectory
add_subdirectory(src)

set(LIBM2K_PC ${CMAKE_CURRENT_BINARY_DIR}/libm2k.pc)
configure_file(libm2k.pc.cmakein ${LIBM2K_PC} @ONLY)
install(FILES ${LIBM2K_PC} DESTINATION "${INSTALL_PKGCONFIG_DIR}")

# install udev rules on Linux
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux" AND INSTALL_UDEV_RULES)
	set(LIBM2K_UDEV_RULES "${CMAKE_CURRENT_SOURCE_DIR}/53-adi-m2k-usb.rules")
	set(UDEV_RULES_PATH "/etc/udev/rules.d" CACHE STRING "Target directory for udev rule installation.")
	install(FILES ${LIBM2K_UDEV_RULES} DESTINATION ${UDEV_RULES_PATH})
endif()

configure_file(libm2k.iss.cmakein ${CMAKE_CURRENT_BINARY_DIR}/libm2k.iss @ONLY)

#Add and build libm2k tools
if (ENABLE_TOOLS)
	message("---- Building tools")
	add_subdirectory(tools)
	add_definitions(-DCOMMUNICATION)
endif()

#Add and build python bindings
if (ENABLE_PYTHON AND SWIG_FOUND)
	message("---- Building Python bindings")
	add_subdirectory(bindings/python)
endif()

#Add and build C# bindings
if (ENABLE_CSHARP AND SWIG_FOUND)
	message("---- Building C# bindings")
	add_subdirectory(bindings/csharp)
endif()

#Add and build LabVIEW wrapper bindings
if (ENABLE_LABVIEW)
	message("---- Building LabVIEW bindings")
	add_subdirectory(bindings/labview)
endif()

#Add and build the examples
if (BUILD_EXAMPLES)
	add_subdirectory(examples)
endif()

# Create an installer if compiling for OSX
if(OSX_PACKAGE)
	set(LIBM2K_PKG ${CMAKE_CURRENT_BINARY_DIR}/libm2k-${PROJECT_VERSION}.g${LIBM2K_VERSION_GIT}.pkg)
	set(LIBM2K_TEMP_PKG ${CMAKE_CURRENT_BINARY_DIR}/libm2k-${VERSION}-temp.pkg)
	set(LIBM2K_DISTRIBUTION_XML ${CMAKE_CURRENT_BINARY_DIR}/Distribution.xml)
	set(LIBM2K_FRAMEWORK_DIR ${CMAKE_CURRENT_BINARY_DIR}/src/libm2k.framework)
	set(LIBM2K_FRAMEWORK_HEADERS_DIR ${LIBM2K_FRAMEWORK_DIR}/Headers)
	configure_file(Distribution.xml.cmakein ${LIBM2K_DISTRIBUTION_XML} @ONLY)

	# Include the headers in the Framework directory, keeping the directory structure healthy.
	# Otherwise, the headers are not included in the .pkg and therefore not installed.
	file(COPY ${CMAKE_SOURCE_DIR}/include/libm2k/ DESTINATION "${LIBM2K_FRAMEWORK_HEADERS_DIR}/libm2k" FILES_MATCHING PATTERN "*.hpp")

	find_program(PKGBUILD_EXECUTABLE
		NAMES pkgbuild
		DOC "OSX Package builder (pkgbuild)")
	mark_as_advanced(PKGBUILD_EXECUTABLE)

	find_program(PRODUCTBUILD_EXECUTABLE
		NAMES productbuild
		DOC "OSX Package builder (productbuild)")
	mark_as_advanced(PRODUCTBUILD_EXECUTABLE)

	set(COPY_TOOLS_COMMAND)
	if (ENABLE_TOOLS)
		list(APPEND COPY_TOOLS_COMMAND
			COMMAND ${CMAKE_COMMAND} -E copy $<TARGET_FILE:m2kcli> ${LIBM2K_FRAMEWORK_DIR}/Tools)
	endif()

	add_custom_command(OUTPUT ${LIBM2K_PKG}
		COMMAND ${CMAKE_COMMAND} -E make_directory ${LIBM2K_FRAMEWORK_DIR}/Tools
		${COPY_TOOLS_COMMAND}
		COMMAND ${PKGBUILD_EXECUTABLE}
			--component ${LIBM2K_FRAMEWORK_DIR}
			--identifier libm2k --version ${PROJECT_VERSION}
			--install-location ${OSX_INSTALL_FRAMEWORKSDIR} ${LIBM2K_TEMP_PKG}
		COMMAND ${PRODUCTBUILD_EXECUTABLE}
			--distribution ${LIBM2K_DISTRIBUTION_XML} ${LIBM2K_PKG}
		COMMAND ${CMAKE_COMMAND} -E remove ${LIBM2K_TEMP_PKG}
		DEPENDS ${PROJECT_NAME} ${M2KCLI_TARGET} ${LIBM2K_DISTRIBUTION_XML}
	)

	if (PKGBUILD_EXECUTABLE AND PRODUCTBUILD_EXECUTABLE)
		add_custom_target(libm2k-pkg ALL DEPENDS ${LIBM2K_PKG})

		install(CODE "execute_process(COMMAND /usr/sbin/installer -pkg ${LIBM2K_PKG} -target /)")
	else()
		message(WARNING "Missing pkgbuild or productbuild: OSX installer won't be created.")
	endif()
endif()

if (NOT OSX_PACKAGE)
	# Support creating some basic binpkgs via `make package`.
	# Disabled if OSX_PACKAGE is enabled, as tarballs would end up empty otherwise.
	option(ENABLE_PACKAGING "Create .deb/.rpm or .tar.gz packages via 'make package'" OFF)

	if(ENABLE_PACKAGING)
		if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
			include(cmake/DarwinPackaging.cmake)
		endif()
		if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
			include(cmake/LinuxPackaging.cmake)
		endif()
	endif()
endif()

add_custom_target(uninstall
    "${CMAKE_COMMAND}" -P "${CMAKE_MODULE_PATH}/uninstall.cmake"
)

=== doc/CMakeLists.txt ===
#
# Copyright (c) 2024 Analog Devices Inc.
#
# This file is part of libm2k
# (see http://www.github.com/analogdevicesinc/libm2k).
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 2.1 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 3.1.3)
project(doc)

find_program(DOXYGEN_PATH doxygen)
if (NOT DOXYGEN_PATH)
    message(FATAL_ERROR "Doxygen not found!")
endif()


set(SOURCES_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../include/libm2k)
set(DOXY_WORKING_DIR ${CMAKE_CURRENT_BINARY_DIR}/doxygen_doc)


set(PROJECT_NAME "libm2k")
set(DOCUMENTED_FILES "${SOURCES_DIR}/m2k.hpp \\
                      ${SOURCES_DIR}/contextbuilder.hpp \\
                      ${SOURCES_DIR}/context.hpp \\
                      ${SOURCES_DIR}/digital/m2kdigital.hpp \\
                      ${SOURCES_DIR}/digital/enums.hpp \\
                      ${SOURCES_DIR}/analog/m2kanalogin.hpp \\
                      ${SOURCES_DIR}/analog/m2kanalogout.hpp \\
                      ${SOURCES_DIR}/analog/m2kpowersupply.hpp \\
                      ${SOURCES_DIR}/analog/dmm.hpp \\
                      ${SOURCES_DIR}/analog/enums.hpp \\
                      ${SOURCES_DIR}/digital/enums.hpp \\
                      ${SOURCES_DIR}/enums.hpp \\
		       ${SOURCES_DIR}/m2khardwaretrigger.hpp \\
		       ${SOURCES_DIR}/enums.hpp \\
                     ${CMAKE_CURRENT_SOURCE_DIR}/mainpage.dox
                      "
)


configure_file(
    Doxyfile_API.in
    ${DOXY_WORKING_DIR}/Doxyfile.doxy
)


if(ENABLE_PYTHON)
	find_package(Sphinx REQUIRED)

	if (NOT SPHINX_EXECUTABLE)
	    message(FATAL_ERROR "Sphinx not found!")
	endif()

	set(BINARY_SPHINX_DIR "${DOXY_WORKING_DIR}/python/html/sphinx")
	# configured documentation tools and intermediate build results
	set(BINARY_BUILD_DIR "${BINARY_SPHINX_DIR}/build")
	# Sphinx cache with pickled ReST documents
	set(SPHINX_CACHE_DIR "${BINARY_SPHINX_DIR}/build/doctrees")
	# HTML output directory
	set(SPHINX_HTML_DIR "${BINARY_SPHINX_DIR}/build/html")

	configure_file(
		"${CMAKE_CURRENT_SOURCE_DIR}/sphinx/source/conf.py.in"
		"${BINARY_SPHINX_DIR}/build/conf.py"
		@ONLY)
	add_custom_target(libm2k_sphinx_doc
		${SPHINX_EXECUTABLE}
		-q -b html
		-c "${BINARY_BUILD_DIR}"
		-d "${SPHINX_CACHE_DIR}"
		"${CMAKE_CURRENT_SOURCE_DIR}/sphinx/source"
		"${SPHINX_HTML_DIR}"
		COMMENT "---Building HTML documentation with Sphinx for Python Bindings")

endif()

add_custom_target(doc
    COMMAND ${DOXYGEN_PATH} Doxyfile.doxy
    COMMAND ${CMAKE_COMMAND} -E make_directory ${DOXY_WORKING_DIR}/html
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/img ${DOXY_WORKING_DIR}/html/img
    COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_CURRENT_SOURCE_DIR}/sphinx ${DOXY_WORKING_DIR}/html/sphinx
    WORKING_DIRECTORY ${DOXY_WORKING_DIR}
)

if(ENABLE_PYTHON)
	add_dependencies(doc libm2k_sphinx_doc)
endif()

=== examples/CMakeLists.txt ===
#
# Copyright (c) 2024 Analog Devices Inc.
#
# This file is part of libm2k
# (see http://www.github.com/analogdevicesinc/libm2k).
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 2.1 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 3.1.3)

add_subdirectory(analog)
add_subdirectory(digital)
add_subdirectory(powersupply)
add_subdirectory(voltmeter)

=== src/CMakeLists.txt ===
#
# Copyright (c) 2024 Analog Devices Inc.
#
# This file is part of libm2k
# (see http://www.github.com/analogdevicesinc/libm2k).
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 2.1 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 3.1.3)

option(OSX_PACKAGE "Create OSX package" OFF)
set(BUILD_SHARED_LIBS ON CACHE BOOL "Build shared libraries")

if(APPLE)
	# build universal binaries by default
	set(CMAKE_OSX_ARCHITECTURES "x86_64")
endif()

if(MSVC)
	if (NOT ENABLE_EXCEPTIONS)
		# support for C/C++ conformant preprocessor in MSVC was added starting with
		# version Visual Studio 2019 version 16.6 (equivalent to 1926)
		# https://devblogs.microsoft.com/cppblog/announcing-full-support-for-a-c-c-conformant-preprocessor-in-msvc/
		if(MSVC_VERSION GREATER_EQUAL 1926)
			remove_definitions("/EHsc /Zc:preprocessor")
		else()
			remove_definitions("/EHsc /experimental:preprocessor")
		endif()
	else()
		if(MSVC_VERSION GREATER_EQUAL 1926)
			add_definitions("/permissive /EHsc /Zc:preprocessor")
		else()
			add_definitions("/permissive /EHsc /experimental:preprocessor")
		endif()
	endif()
endif()

SET(CMAKE_EXE_LINKER_FLAGS  "/FORCE")

FILE(GLOB_RECURSE SRC_LIST  *.cpp *_impl.hpp */*_impl.hpp)

FILE(GLOB_RECURSE HEADERS_LIST ${CMAKE_SOURCE_DIR}/include/libm2k/*.hpp)
FILE(GLOB_RECURSE HEADERS_LIST_LV ${CMAKE_SOURCE_DIR}/include/libm2k/*.h)

if (ENABLE_TOOLS)
	FILE(GLOB_RECURSE COMMUNICATION_SRC_LIST ../tools/communication/src/*.cpp)
	list(APPEND SRC_LIST ${COMMUNICATION_SRC_LIST})
else()
	foreach(filepath ${HEADERS_LIST})
		if(${filepath} MATCHES "${CMAKE_SOURCE_DIR}/include/libm2k/tools/*")
			list(REMOVE_ITEM HEADERS_LIST ${filepath})
		endif()
	endforeach()
endif()

#Create the libm2k library
add_library(${PROJECT_NAME} SHARED
			${SRC_LIST}
			${HEADERS_LIST}
			${DEVICES})

# build with LIBM2K_EXPORTS defined in order to export everything that is marked with LIBM2K_API.
target_compile_definitions(${PROJECT_NAME} PRIVATE LIBM2K_EXPORTS)
if (ENABLE_LOG)
	target_compile_definitions(${PROJECT_NAME} PUBLIC LIBM2K_ENABLE_LOG)
endif()
if (MSVC)
	add_definitions("/MD /wd4250 /wd4251 /wd4275 /wd5105")
endif()

if(NOT MSVC)
	target_compile_options(${PROJECT_NAME}
			PRIVATE
			-Wall
			-Wextra)
	if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
		target_compile_options(${PROJECT_NAME}
				PRIVATE
				-Wreturn-stack-address)
	elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
		target_compile_options(${PROJECT_NAME}
				PRIVATE
				-Wreturn-local-addr)
	endif()
endif()

target_include_directories(${PROJECT_NAME}
    PUBLIC
        $<INSTALL_INTERFACE:include>
        $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>
        $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/include>
        ${IIO_INCLUDE_DIRS}
    PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}
)

if (NOT WIN32)
	find_library(PTHREAD_LIBRARIES pthread)
	if (PTHREAD_LIBRARIES)
                target_link_libraries(libm2k PRIVATE ${PTHREAD_LIBRARIES})
	endif()
endif()


#Link the required dependencies
target_link_libraries(${PROJECT_NAME}
		PUBLIC
		${IIO_LIBRARIES}
		)
if (ENABLE_LOG)
	target_link_libraries(${PROJECT_NAME}
			PUBLIC
			glog::glog
			)
endif()


#Take care of the library properties
set_target_properties(${PROJECT_NAME} PROPERTIES
        VERSION ${PROJECT_VERSION}
	SOVERSION ${PROJECT_VERSION}
)

if (MSVC)
	set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME libm2k)
endif()


if (APPLE)
	set_target_properties(${PROJECT_NAME} PROPERTIES FRAMEWORK FALSE)
	set(CMAKE_MACOSX_RPATH ON)
	if (OSX_PACKAGE)
		set_target_properties(${PROJECT_NAME} PROPERTIES FRAMEWORK TRUE)
		get_filename_component(OSX_INSTALL_FRAMEWORKSDIR "${OSX_INSTALL_FRAMEWORKSDIR}" REALPATH BASE_DIR "${CMAKE_CURRENT_BINARY_DIR}")
		set(SKIP_INSTALL_ALL ${OSX_PACKAGE})
	endif()
endif()

install(TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}Targets
	ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
	FRAMEWORK DESTINATION "${OSX_INSTALL_FRAMEWORKSDIR}"
)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/include/libm2k/ DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}"
	FILES_MATCHING PATTERN "*.hpp")
install(FILES ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}/version.hpp DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})

# Add alias to libm2k as libm2k::libm2k
add_library(${PROJECT_NAME}::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

install(EXPORT ${PROJECT_NAME}Targets
    FILE ${PROJECT_NAME}Targets.cmake
    NAMESPACE ${PROJECT_NAME}::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

include(CMakePackageConfigHelpers)
write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake
    VERSION ${VERSION}
    COMPATIBILITY AnyNewerVersion
)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake ${CMAKE_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})

=== tests/requirements.txt ===
html-testRunner~=1.2.1
matplotlib~=3.8.0
numpy~=1.26.2
pandas~=2.1.3
pdoc3~=0.10.0
scipy~=1.11.4

=== tools/CMakeLists.txt ===
#
# Copyright (c) 2024 Analog Devices Inc.
#
# This file is part of libm2k
# (see http://www.github.com/analogdevicesinc/libm2k).
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 2.1 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 3.1.3)

add_subdirectory(m2kcli)
add_subdirectory(communication/examples)

=== bindings/csharp/CMakeLists.txt ===
#
# Copyright (c) 2024 Analog Devices Inc.
#
# This file is part of libm2k
# (see http://www.github.com/analogdevicesinc/libm2k).
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 2.1 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 2.8.7)

set(CSHARP_WRAPPER_DLL ${PROJECT_NAME}-sharp-cxx-wrap)

FIND_PACKAGE(SWIG REQUIRED)
include(UseSWIG)
INCLUDE_DIRECTORIES(
	${CMAKE_SOURCE_DIR}/include
	${CMAKE_CURRENT_SOURCE_DIR})

SET(CMAKE_SWIG_FLAGS "")
SET_SOURCE_FILES_PROPERTIES(../${PROJECT_NAME}.i PROPERTIES CPLUSPLUS ON)

# outdir for .so file
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

set_property(SOURCE ../${PROJECT_NAME}.i PROPERTY SWIG_MODULE_NAME "libm2k")

if(ENABLE_TOOLS)
	execute_process(
		COMMAND ${SWIG_EXECUTABLE} -csharp -c++ -DCOMMUNICATION -outdir ${CMAKE_CURRENT_BINARY_DIR} -o ${CMAKE_CURRENT_BINARY_DIR}/libm2kCSHARP_wrap.cxx -dllimport ${CSHARP_WRAPPER_DLL}
		-I${CMAKE_SOURCE_DIR}/include -I${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../${PROJECT_NAME}.i
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		OUTPUT_VARIABLE swig_generated_output
		RESULT_VARIABLE swig_generated_res
		ERROR_VARIABLE swig_generated_error
		INPUT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/../${PROJECT_NAME}.i
		)
else()
	execute_process(
			COMMAND ${SWIG_EXECUTABLE} -csharp -c++ -outdir ${CMAKE_CURRENT_BINARY_DIR} -o ${CMAKE_CURRENT_BINARY_DIR}/libm2kCSHARP_wrap.cxx -dllimport ${CSHARP_WRAPPER_DLL}
			-I${CMAKE_SOURCE_DIR}/include -I${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../${PROJECT_NAME}.i
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			OUTPUT_VARIABLE swig_generated_output
			RESULT_VARIABLE swig_generated_res
			ERROR_VARIABLE swig_generated_error
			INPUT_FILE ${CMAKE_CURRENT_SOURCE_DIR}/../${PROJECT_NAME}.i
	)
endif()

if (${swig_generated_res})
	message("------- SWIG failed to generate the C# wrapper.")
		message(${swig_generated_error})
endif()

#############################################################################################
##	build a libm2k-sharp-wrapper.dll which contains the CSHARP_wrapper.cxx generated
##	by SWIG
#############################################################################################

set(SRC_WRAPPER_FILE ${CMAKE_CURRENT_BINARY_DIR}/libm2kCSHARP_wrap.cxx)
set_source_files_properties(${SRC_WRAPPER_FILE} PROPERTIES GENERATED TRUE)

if(APPLE)
	# build universal binaries by default
	set(CMAKE_OSX_ARCHITECTURES "x86_64")
endif()

include_directories(
	SYSTEM
	${CMAKE_CURRENT_BINARY_DIR}
	${CMAKE_SOURCE_DIR}/src
	${CMAKE_SOURCE_DIR}/include
	${IIO_INCLUDE_DIRS})

add_library(${CSHARP_WRAPPER_DLL} SHARED ${SRC_WRAPPER_FILE})

if(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	target_compile_options(${CSHARP_WRAPPER_DLL}
			PRIVATE
			-Wno-maybe-uninitialized)
endif()

target_include_directories(${CSHARP_WRAPPER_DLL} PRIVATE ${CMAKE_SOURCE_DIR}/include)

#Link the required dependencies
target_link_libraries(${CSHARP_WRAPPER_DLL}
	${PROJECT_NAME}
	${IIO_LIBRARIES})

#Take care of the library properties
set_target_properties(${CSHARP_WRAPPER_DLL} PROPERTIES
	VERSION ${PROJECT_VERSION}
	SOVERSION ${PROJECT_VERSION}
	)


install(TARGETS ${CSHARP_WRAPPER_DLL}
	ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
	RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
	)


#################################################################################
## build the C# dll using MCS/CSC and add the Assembly Info
#################################################################################

if (WIN32)
	set(MCS_EXECUTABLE_NAME csc)
else()
	set(MCS_EXECUTABLE_NAME mcs)
endif()

find_program(MCS_EXECUTABLE
	NAMES ${MCS_EXECUTABLE_NAME}
	HINTS "C:/Windows/Microsoft.NET/Framework/v4.0.30319"
	PATHS ENV MCS_EXECUTABLE_PATH
	DOC "C# compiler")
	mark_as_advanced(MCS_EXECUTABLE)

	if (MCS_EXECUTABLE)
		set(LIBM2K_CS_PC_IN "${CMAKE_CURRENT_SOURCE_DIR}/libm2k-sharp.pc.cmakein")
		set(LIBM2K_CS_PC "${CMAKE_CURRENT_BINARY_DIR}/libm2k-sharp.pc")
		configure_file(${LIBM2K_CS_PC_IN} ${LIBM2K_CS_PC} @ONLY)
		if(NOT SKIP_INSTALL_ALL)
			install(FILES ${LIBM2K_CS_PC} DESTINATION "${CMAKE_INSTALL_PREFIX}/lib/pkgconfig")
		endif()

		set(LIBM2K_CS_DLL_CONFIG_IN "${CMAKE_CURRENT_SOURCE_DIR}/libm2k-sharp.dll.config.cmakein")
		set(LIBM2K_CS_DLL_CONFIG "${CMAKE_CURRENT_BINARY_DIR}/libm2k-sharp.dll.config")
		configure_file(${LIBM2K_CS_DLL_CONFIG_IN} ${LIBM2K_CS_DLL_CONFIG} @ONLY)
		if(NOT SKIP_INSTALL_ALL)
			install(FILES ${LIBM2K_CS_DLL_CONFIG} DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/cli/libm2k-sharp-${VERSION})
		endif()

		set(LIBM2K_CS_VERSION ${VERSION}.0.0)
		set(LIBM2K_CS_INFO_IN ${CMAKE_CURRENT_SOURCE_DIR}/AssemblyInfo.cs.in)
		set(LIBM2K_CS_INFO ${CMAKE_CURRENT_BINARY_DIR}/AssemblyInfo.cs)
		configure_file(${LIBM2K_CS_INFO_IN} ${LIBM2K_CS_INFO} @ONLY)

		set(LIBM2K_CS_DLL "${CMAKE_BINARY_DIR}/libm2k-sharp.dll")



		FILE(GLOB CSHARP_SRC_LIST ${CMAKE_CURRENT_BINARY_DIR}/*.cs)
		set_source_files_properties(${CSHARP_SRC_LIST} PROPERTIES GENERATED TRUE)

		set(LIBM2K_CS_SOURCES ${CSHARP_SRC_LIST})

		add_definitions(-DNO_ERROR_CATCHING) #disable internal error catching and allow swig to do the error catching itself

		foreach(SRC ${LIBM2K_CS_SOURCES})
			file(TO_NATIVE_PATH ${SRC} TMP)
			set(LIBM2K_CS_SOURCES_REALPATH ${LIBM2K_CS_SOURCES_REALPATH} ${TMP})
		endforeach(SRC)

		file(TO_NATIVE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/key.snk SIGN_KEY)
		file(TO_NATIVE_PATH ${LIBM2K_CS_DLL} LIBM2K_CS_DLL_OUT)

		add_custom_command(OUTPUT ${LIBM2K_CS_DLL}
			COMMAND ${MCS_EXECUTABLE} /target:library /out:${LIBM2K_CS_DLL_OUT} /keyfile:${SIGN_KEY} ${LIBM2K_CS_SOURCES_REALPATH}
			DEPENDS ${LIBM2K_CS_SOURCES})

		add_custom_target(libm2k-sharp ALL DEPENDS ${LIBM2K_CS_DLL} ${CSHARP_WRAPPER_DLL})
		add_dependencies(libm2k-sharp ${CSHARP_WRAPPER_DLL})

	endif()

=== bindings/labview/CMakeLists.txt ===
#
# Copyright (c) 2024 Analog Devices Inc.
#
# This file is part of libm2k
# (see http://www.github.com/analogdevicesinc/libm2k).
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 2.1 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 3.1.3)
set (CMAKE_CXX_STANDARD 11)
#Find libiio and link it to the targets generated by this project

if (NOT WIN32)
	find_library(PTHREAD_LIBRARIES pthread)
endif()

if (LIBM2K_VERSION)			# in-source build
	set(PROJECT_VERSION ${LIBM2K_VERSION})
else()					# standalone build
	set(PROJECT_VERSION "1.0.0")
	find_package(libm2k REQUIRED)
endif()
add_library(libm2k_lv SHARED "${CMAKE_CURRENT_SOURCE_DIR}/libm2k_lv.cpp" 
				"${CMAKE_CURRENT_SOURCE_DIR}/libm2k_lv.h")

target_link_libraries(libm2k_lv PRIVATE libm2k::libm2k)

=== bindings/python/CMakeLists.txt ===
#
# Copyright (c) 2024 Analog Devices Inc.
#
# This file is part of libm2k
# (see http://www.github.com/analogdevicesinc/libm2k).
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 2.1 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 2.8.7)

set(CMAKE_EXPORT_COMPILE_COMMANDS ON CACHE INTERNAL "")
set(CMAKE_VERBOSE_MAKEFILE ON)
string(REGEX MATCHALL "([^\ ]+\ |[^\ ]+$)" CMAKE_CXX_LIST "${CMAKE_CXX_FLAGS}")
FOREACH(CXX_COMPILE_FLAG ${CMAKE_CXX_LIST})
	string(REPLACE " " "" CXX_COMPILE_FLAG "${CXX_COMPILE_FLAG}")
	set(EXTRA_COMPILE_FLAGS '${CXX_COMPILE_FLAG}',${EXTRA_COMPILE_FLAGS})
ENDFOREACH()

if(NOT ${CMAKE_VERSION} VERSION_LESS "3.13.5")
	# Check CMake Policy added in v3.13 regarding the SWIG generated target name
	# https://cmake.org/cmake/help/v3.14/policy/CMP0078.html
	cmake_policy(SET CMP0078 OLD)
endif()
set(SWIG_OUTPUT_NAME libm2k)

if(NOT ${CMAKE_VERSION} VERSION_LESS "3.14.7")
	# Check CMake Policy added in v3.14 regarding the SWIG_MODULE_NAME flag
	# https://cmake.org/cmake/help/v3.14/policy/CMP0086.html
	cmake_policy(SET CMP0086 NEW)
endif()

get_filename_component(IIO_LIBRARY_DIR ${IIO_LIBRARIES} DIRECTORY)

if(${CMAKE_VERSION} VERSION_LESS "3.12.0")
	if (NOT WIN32)
		set(Python_ADDITIONAL_VERSIONS 3)
	endif()

	include(FindPythonInterp)
	include(FindPythonLibs)

	set(Python_Interpreter_FOUND ${PYTHONINTERP_FOUND})
	set(Python_EXECUTABLE ${PYTHON_EXECUTABLE})
	set(Python_LIBRARIES ${PYTHON_LIBRARIES})
	set(Python_INCLUDE_PATH ${PYTHON_INCLUDE_PATH})
	set(Python_INCLUDE_DIRS ${PYTHON_INCLUDE_DIRS})
else()
	if(PYTHON_EXECUTABLE)
		set(Python_EXECUTABLE ${PYTHON_EXECUTABLE})
	endif()
	if (PYTHON_LIBRARY)
		set(Python_LIBRARY ${PYTHON_LIBRARY})
	endif()
	if (PYTHON_INCLUDE_DIR)
		set(Python_INCLUDE_DIR ${PYTHON_INCLUDE_DIR})
	endif()
	message(STATUS "bin=${Python_EXECUTABLE} lib=${Python_LIBRARY} inc=${Python_INCLUDE_DIR}")
	find_package(Python COMPONENTS Interpreter Development)
	message(STATUS "Python_EXECUTABLE ${Python_EXECUTABLE}")
endif()

FIND_PACKAGE(SWIG REQUIRED)
include(UseSWIG)

INCLUDE_DIRECTORIES(${Python_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/include
	${CMAKE_CURRENT_SOURCE_DIR})

if(ENABLE_TOOLS)
	set(CMAKE_SWIG_FLAGS -DCOMMUNICATION)
	set(EXTRA_COMPILE_FLAGS '-DCOMMUNICATION',${EXTRA_COMPILE_FLAGS})
else()
	set(CMAKE_SWIG_FLAGS "")
endif()

if(ENABLE_DOC)
	string(COMPARE LESS ${SWIG_VERSION} "4.0.0" SWIG_VERSION_ERROR)
	if(SWIG_VERSION_ERROR)
		message("-- SWIG Doxygen for Python disabled. SWIG 4.0.0 required (found version " ${SWIG_VERSION} " )")
	else()
		message("-- SWIG Doxygen for Python enabled (found version " ${SWIG_VERSION} " )")
		set(CMAKE_SWIG_FLAGS ${CMAKE_SWIG_FLAGS} "-doxygen")
		set(CMAKE_SWIG_FLAGS ${CMAKE_SWIG_FLAGS} -DDOXYGEN)
	endif()
endif()

SET_SOURCE_FILES_PROPERTIES(../${PROJECT_NAME}.i PROPERTIES CPLUSPLUS ON)

set(CMAKE_SWIG_OUTDIR ${CMAKE_BINARY_DIR})
set(SWIG_OUTFILE_DIR ${CMAKE_BINARY_DIR})
# outdir for .so file
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

set_property(SOURCE ../${PROJECT_NAME}.i PROPERTY SWIG_MODULE_NAME "libm2k")

if(${CMAKE_VERSION} VERSION_LESS "3.8.2")
	swig_add_module(${SWIG_OUTPUT_NAME} python ../${PROJECT_NAME}.i)
else()
	SWIG_ADD_LIBRARY(${SWIG_OUTPUT_NAME} TYPE MODULE LANGUAGE python OUTPUT_DIR ${CMAKE_BINARY_DIR} OUTFILE_DIR ${CMAKE_BINARY_DIR} SOURCES ../${PROJECT_NAME}.i)
endif()

if (SWIG_MODULE_libm2k_REAL_NAME)
	set(SWIG_OUTPUT_NAME ${SWIG_MODULE_libm2k_REAL_NAME})
endif()

# Handle Anaconda issues on OSX
execute_process(COMMAND ${Python_EXECUTABLE} -c "import sysconfig; print(sysconfig.get_config_var('LDSHARED'))"
	RESULT_VARIABLE PY_CONF_VAR
	OUTPUT_VARIABLE PY_LD_SHARED
	OUTPUT_STRIP_TRAILING_WHITESPACE)

IF("${PY_LD_SHARED}" MATCHES "dynamic_lookup")
	set(PYTHON_LINK OFF)
ELSE()
	SET(PYTHON_LINK ON)
ENDIF()

IF (NOT PYTHON_LINK)
	IF (APPLE)
		message("--- Using LD_SHARED " ${PY_LD_SHARED})
		SET_TARGET_PROPERTIES(${SWIG_OUTPUT_NAME} PROPERTIES LINK_FLAGS "-flat_namespace -undefined dynamic_lookup")
		set(EXTRA_LINK_FLAGS '-flat_namespace','-undefined','dynamic_lookup',${EXTRA_LINK_FLAGS})
	ENDIF()
ENDIF()

if (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
	target_compile_options(_${PROJECT_NAME}
			PRIVATE
			-Wno-deprecated-declarations)
	set(EXTRA_COMPILE_FLAGS '-Wno-deprecated-declarations',${EXTRA_COMPILE_FLAGS})
elseif(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
	target_compile_options(_${PROJECT_NAME}
			PRIVATE
			-Wno-unused-but-set-variable)
	set(EXTRA_COMPILE_FLAGS '-Wno-unused-but-set-variable',${EXTRA_COMPILE_FLAGS})
endif()

target_include_directories(_${PROJECT_NAME} PRIVATE
	${Python_INCLUDE_DIRS}
	${CMAKE_SOURCE_DIR}/include)

target_link_libraries(_${PROJECT_NAME} ${PROJECT_NAME})

IF (PYTHON_LINK)
	target_link_libraries(_${PROJECT_NAME} ${Python_LIBRARIES})
ENDIF()

string(REPLACE " " "','" CXX_COMPILE_FLAG "${CMAKE_SHARED_LIBRARY_CXX_FLAGS}")
set(EXTRA_COMPILE_FLAGS '${CXX_COMPILE_FLAG}',${EXTRA_COMPILE_FLAGS})

if(NOT APPLE)
	string(REPLACE " " "','" CXX_LINK_FLAG "${CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS}")
	set(EXTRA_LINK_FLAGS '${CXX_LINK_FLAG}',${EXTRA_LINK_FLAGS})
endif()

set(PYTHON_EXECUTABLE_LIB_VERSION ${Python_EXECUTABLE})
if(UNIX)
	if(NOT APPLE)
		set_target_properties(${SWIG_OUTPUT_NAME} PROPERTIES
			INSTALL_RPATH	"$ORIGIN")
	else()
		set_target_properties(${SWIG_OUTPUT_NAME} PROPERTIES
			SUFFIX ".so"
			INSTALL_RPATH	"@loader_path")
#		set_property(TARGET ${SWIG_MODULE_pyBar_REAL_NAME} APPEND PROPERTY
#			LINK_FLAGS "-flat_namespace -undefined suppress")
		set(EXTRA_LINK_FLAGS '-flat_namespace','-undefined','suppress',${EXTRA_LINK_FLAGS})
		set(EXTRA_LINK_FLAGS '-F${IIO_LIBRARY_DIR}','-F${CMAKE_BINARY_DIR}/src',${EXTRA_LINK_FLAGS})
		set(EXTRA_LINK_FLAGS '-framework','${PROJECT_NAME}',${EXTRA_LINK_FLAGS})
		set(EXTRA_LINK_FLAGS '-framework','iio',${EXTRA_LINK_FLAGS})
		if (NOT CMAKE_OSX_DEPLOYMENT_TARGET)
			set(CMAKE_OSX_DEPLOYMENT_TARGET ${MACOSX_DEPLOYMENT_TARGET})
		endif()
		set(EXTRA_LINK_FLAGS '-mmacosx-version-min=${CMAKE_OSX_DEPLOYMENT_TARGET}',${EXTRA_LINK_FLAGS})
		string(REPLACE " " "','" CXX_COMPILE_FLAG "${CMAKE_SHARED_MODULE_CREATE_CXX_FLAGS}")
		set(EXTRA_LINK_FLAGS '${CXX_COMPILE_FLAG}',${EXTRA_LINK_FLAGS})
	endif()
endif()

if (WIN32)
  # disable lib prefix on windows with mingw
  set_target_properties(${SWIG_OUTPUT_NAME} PROPERTIES PREFIX "")
endif()

set(SETUP_PY_IN ${CMAKE_CURRENT_SOURCE_DIR}/setup.py.cmakein)
set(SETUP_PY ${CMAKE_BINARY_DIR}/setup.py)
configure_file(${SETUP_PY_IN} ${SETUP_PY})

configure_file(${CMAKE_SOURCE_DIR}/bindings/libm2k.i ${CMAKE_BINARY_DIR}/libm2k.i COPYONLY)
configure_file(${CMAKE_SOURCE_DIR}/bindings/python/README.md ${CMAKE_BINARY_DIR}/README.md COPYONLY)

add_custom_target(${PROJECT_NAME}py ALL DEPENDS _${PROJECT_NAME} WORKING_DIRECTORY
	${CMAKE_BINARY_DIR} COMMAND ${PYTHON_EXECUTABLE_LIB_VERSION} ${SETUP_PY} build)

if(NOT SKIP_INSTALL_ALL)
	install(CODE "execute_process(WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
		COMMAND ${PYTHON_EXECUTABLE_LIB_VERSION} ${SETUP_PY} install
		--record=${CMAKE_BINARY_DIR}/install_manifest_py.txt
		--root=\$ENV{DESTDIR}/ --prefix=${CMAKE_INSTALL_PREFIX})")
endif()

=== doc/sphinx/Makefile ===
#
# Copyright (c) 2024 Analog Devices Inc.
#
# This file is part of libm2k
# (see http://www.github.com/analogdevicesinc/libm2k).
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 2.1 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line, and also
# from the environment for the first two.
SPHINXOPTS    ?=
SPHINXBUILD   ?= sphinx-build
SOURCEDIR     = source
BUILDDIR      = build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

=== examples/analog/CMakeLists.txt ===
#
# Copyright (c) 2024 Analog Devices Inc.
#
# This file is part of libm2k
# (see http://www.github.com/analogdevicesinc/libm2k).
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 2.1 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 3.1.3)
set (CMAKE_CXX_STANDARD 11)
project(analog LANGUAGES CXX)


if (NOT WIN32)
	find_library(PTHREAD_LIBRARIES pthread)
endif()

if (LIBM2K_VERSION)			# in-source build
	set(PROJECT_VERSION ${LIBM2K_VERSION})
else()					# standalone build
	set(PROJECT_VERSION "1.0.0")
	find_package(libm2k REQUIRED)
endif()

add_executable(analog_in_out "analog_in_out.cpp")
add_executable(streaming_one_channel "streaming_one_channel.cpp")
add_executable(streaming_synchronized "streaming_synchronized.cpp")
add_executable(sync_stream_diff_frequencies "sync_stream_diff_frequencies.cpp")
add_executable(stream_test_adc "stream_test_adc.cpp")
add_executable(stream_test_dac "stream_test_dac.cpp")
add_executable(analog_out_set_voltage "analog_out_set_voltage.cpp")
add_executable(triggered_aout "triggered_aout.cpp")

target_link_libraries(analog_in_out PRIVATE libm2k::libm2k)
target_link_libraries(streaming_one_channel PRIVATE libm2k::libm2k)
target_link_libraries(streaming_synchronized PRIVATE libm2k::libm2k)
target_link_libraries(sync_stream_diff_frequencies PRIVATE libm2k::libm2k)
target_link_libraries(stream_test_adc PRIVATE libm2k::libm2k)
target_link_libraries(stream_test_dac PRIVATE libm2k::libm2k)
target_link_libraries(analog_out_set_voltage PRIVATE libm2k::libm2k)
target_link_libraries(triggered_aout PRIVATE libm2k::libm2k)

if (PTHREAD_LIBRARIES)
	target_link_libraries(sync_stream_diff_frequencies PRIVATE ${PTHREAD_LIBRARIES})
	target_link_libraries(stream_test_adc PRIVATE ${PTHREAD_LIBRARIES})
	target_link_libraries(stream_test_dac PRIVATE ${PTHREAD_LIBRARIES})
endif()

=== examples/digital/CMakeLists.txt ===
#
# Copyright (c) 2024 Analog Devices Inc.
#
# This file is part of libm2k
# (see http://www.github.com/analogdevicesinc/libm2k).
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 2.1 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
#

cmake_minimum_required(VERSION 3.1.3)
set (CMAKE_CXX_STANDARD 11)
project(digital LANGUAGES CXX)


if (LIBM2K_VERSION)			# in-source build
	set(PROJECT_VERSION ${LIBM2K_VERSION})
else()					# standalone build
	set(PROJECT_VERSION "1.0.0")
	find_package(libm2k REQUIRED)
endif()

if (NOT WIN32)
	find_library(PTHREAD_LIBRARIES pthread)
endif()

add_executable(${PROJECT_NAME} "main.cpp")
add_executable(${PROJECT_NAME}_stream_test "stream_test.cpp")
target_link_libraries(${PROJECT_NAME} PRIVATE libm2k::libm2k)
target_link_libraries(${PROJECT_NAME}_stream_test PRIVATE libm2k::libm2k ${PTHREAD_LIBRARIES})

=== debian/changelog ===
libm2k (0.9.0-4) unstable; urgency=medium

  * Use -DCMAKE_POLICY_VERSION_MINIMUM=3.5 (Closes: #1113172)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 13 Oct 2025 22:53:18 -0400

libm2k (0.9.0-3) unstable; urgency=medium

  [Michael Biebl]
  * Move aliased files from / to /usr (DEP17) (Closes: #1087698)

  [ A. Maitland Bottoms ]
  * correct build with --no-arch-any --arch-all (Closes: #1087664)

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 18 Nov 2024 20:29:51 -0500

libm2k (0.9.0-2) unstable; urgency=medium

  * Upload to unstable

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 16 Nov 2024 09:51:22 -0500

libm2k (0.9.0-1) experimental; urgency=medium

  * Package for Debian (Closes: #990057)

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 25 Oct 2024 23:25:54 -0400

=== debian/control ===
Source: libm2k
Section: science
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               libgoogle-glog-dev,
               libiio-dev,
               python3-dev,
               python3-setuptools,
               swig
Build-Depends-Indep: doxygen,
                     graphviz,
                     python3-sphinx,
                     python3-sphinx-rtd-theme
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://github.com/analogdevicesinc/libm2k
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/libm2k
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/libm2k.git

Package: libm2k0.9.0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: ADI library for interfacing with the ADALM2000
 libm2k is a C++ library for interfacing with the ADALM2000.
 These M2K components represent the functionalities of ADALM2000:
 .
  - AnalogIn - oscilloscope or voltmeter
  - AnalogOut - signal generator
  - Digital - logic analyzer or pattern generator
  - PowerSupply - constant voltage generator
  - DMM - digital multimeter
 .
 This package installs the C++ library itself.

Package: libm2k-dev
Architecture: any
Section: libdevel
Depends: libm2k0.9.0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: ADI library headers for interfacing with the ADALM2000
 libm2k is a C++ library for interfacing with the ADALM2000.
 These M2K components represent the functionalities of ADALM2000:
 .
  - AnalogIn - oscilloscope or voltmeter
  - AnalogOut - signal generator
  - Digital - logic analyzer or pattern generator
  - PowerSupply - constant voltage generator
  - DMM - digital multimeter
 .
 This package installs the C++ headers and development files.

Package: libm2k-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-sphinxdoc, ${misc:Depends}, ${shlibs:Depends}
Description: ADI ADALM2000 documentation
 libm2k is a C++ library for interfacing with the ADALM2000.
 These M2K components represent the functionalities of ADALM2000:
 .
  - AnalogIn - oscilloscope or voltmeter
  - AnalogOut - signal generator
  - Digital - logic analyzer or pattern generator
  - PowerSupply - constant voltage generator
  - DMM - digital multimeter
 .
 This package installs the Doxygen made documentation.

Package: m2kcli
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: ADI tool for interfacing with the ADALM2000
 libm2k is a C++ library for interfacing with the ADALM2000.
 These M2K components represent the functionalities of ADALM2000:
 .
  - AnalogIn - oscilloscope or voltmeter
  - AnalogOut - signal generator
  - Digital - logic analyzer or pattern generator
  - PowerSupply - constant voltage generator
  - DMM - digital multimeter
 .
 This package installs the m2kcli command-line tool.

Package: python3-libm2k
Architecture: any
Section: python
Depends: libm2k0.9.0 (= ${binary:Version}),
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Python ADI library for interfacing with the ADALM2000
 Python libm2k library for interfacing with the ADALM2000.
 These M2K components represent the functionalities of ADALM2000:
 .
  - AnalogIn - oscilloscope or voltmeter
  - AnalogOut - signal generator
  - Digital - logic analyzer or pattern generator
  - PowerSupply - constant voltage generator
  - DMM - digital multimeter
 .
 This package installs the Python bindings for the library.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_HOST_MULTIARCH
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with python3 --buildsystem=cmake

override_dh_auto_configure-arch:
	dh_auto_configure --buildsystem=cmake -- \
	-DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
	-DCMAKE_SKIP_BUILD_RPATH=ON \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DENABLE_PYTHON=ON \
	-DENABLE_LOG=ON \
	-DENABLE_TOOLS=ON

override_dh_auto_configure-indep:
	dh_auto_configure --buildsystem=cmake -- \
	-DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
	-DCMAKE_SKIP_BUILD_RPATH=ON \
	-DCMAKE_VERBOSE_MAKEFILE=ON \
	-DCMAKE_BUILD_TYPE=RelWithDebInfo \
	-DENABLE_PYTHON=ON \
	-DENABLE_LOG=ON \
	-DENABLE_TOOLS=ON \
	-DENABLE_DOC=ON

override_dh_auto_build-indep:
	dh_auto_build
	dh_auto_build -- doc

=== debian/watch ===
version=4
 opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%,uversionmangle=s/-rc/~rc/" \
 https://github.com/analogdevicesinc/libm2k/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@ debian uupdate
